# struct CSV::Row

- CSV::Row
- Struct
- Value
- Object

##
Overview

A Row of a `CSV::WithHeaders` instance.

##
Defined in:

##
Instance Method Summary

- #[](header : String) : String

  Returns the current row's value corresponding to the given header name.

- #[](column : Int) : String

  Returns this row's value at the given column index.

- #[](header_pattern : Regex) : String

  Returns this row's value corresponding to the given header_pattern.

- #[]?(header : String) : String?

  Returns this row's value corresponding to the given header name.

- #[]?(column : Int) : String?

  Returns this row's value at the given column index.

- #[]?(header_pattern : Regex) : String?

  Returns this row's value corresponding to the given header_pattern.

- #size

  Returns the number of columns in this row, regardless of the number of headers (if requested).

- #to_a : Array(String)

  Converts this row to an `Array`.

- #to_h : Hash(String, String)

  Converts this row to a `Hash`.

- #values_at(*columns : Int)

  Returns a tuple of this row's values at given indices A negative index counts from the end.

- #values_at(*headers : String)

  Returns a tuple of this row's values corresponding to the given headers Raises `KeyError` if any header doesn't exist.

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Instance Method Detail

def [](header : String) : String #

Returns the current row's value corresponding to the given header name. Raises `KeyError` if no such header exists. Raises `CSV::Error` if headers were not requested.

def [](column : Int) : String #

Returns this row's value at the given column index. A negative index counts from the end. Raises `IndexError` if no such column exists.

def [](header_pattern : Regex) : String #

Returns this row's value corresponding to the given header_pattern. Raises `KeyError` if no such header exists. Raises `CSV::Error` if headers were not requested.

def []?(header : String) : String? #

Returns this row's value corresponding to the given header name. Returns `nil` if no such header exists. Raises `CSV::Error` if headers were not requested.

def []?(column : Int) : String? #

Returns this row's value at the given column index. A negative index counts from the end. Returns `nil` if no such column exists.

def []?(header_pattern : Regex) : String? #

Returns this row's value corresponding to the given header_pattern. Returns `nil` if no such header exists. Raises `CSV::Error` if headers were not requested.

def size #

Returns the number of columns in this row, regardless of the number of headers (if requested).

def to_a : Array(String) #

Converts this row to an `Array`.

def to_h : Hash(String, String) #

Converts this row to a `Hash`.

def values_at(*columns : Int) #

Returns a tuple of this row's values at given indices A negative index counts from the end. Raises `IndexError` if any column doesn't exist The behavior of returning a tuple is similar to `Hash#values_at`

def values_at(*headers : String) #

Returns a tuple of this row's values corresponding to the given headers Raises `KeyError` if any header doesn't exist. Raises `CSV::Error` if headers were not requested The behavior of returning a tuple is similar to `Hash#values_at`